'use strict';

var chunkQMF3JN35_js = require('./chunk-QMF3JN35.js');
var React = require('react');
var PropTypes = require('prop-types');
var jsxRuntime = require('react/jsx-runtime');

function _interopDefault (e) { return e && e.__esModule ? e : { default: e }; }

function _interopNamespace(e) {
  if (e && e.__esModule) return e;
  var n = Object.create(null);
  if (e) {
    Object.keys(e).forEach(function (k) {
      if (k !== 'default') {
        var d = Object.getOwnPropertyDescriptor(e, k);
        Object.defineProperty(n, k, d.get ? d : {
          enumerable: true,
          get: function () { return e[k]; }
        });
      }
    });
  }
  n.default = e;
  return Object.freeze(n);
}

var React__namespace = /*#__PURE__*/_interopNamespace(React);
var PropTypes__default = /*#__PURE__*/_interopDefault(PropTypes);

/**
  * @pigment-css/react v0.0.30
  *
  * @license MIT
  * This source code is licensed under the MIT license found in the
  * LICENSE file in the root directory of this source tree.
  */
 
var Box = React__namespace.forwardRef(
  (_a, ref) => {
    var _b = _a, {
      as = "div",
      component: component,
      sx: sx,
      className,
      style
    } = _b, other = chunkQMF3JN35_js.__objRest(_b, [
      "as",
      // Added to support compatibility with @mui/system
      "component",
      /**
       * The type of the transformed sx prop is either a
       * "string" if the css passed was fully static or an
       * object with the following shape:
       * {
       *  className: string,
       *  vars: Record<string, [string | number, boolean]>
       * }
       */
      "sx",
      "className",
      "style"
    ]);
    const Component = component != null ? component : as;
    const sxClass = typeof sx === "string" ? sx : sx == null ? void 0 : sx.className;
    const classes = [className, sxClass].filter(Boolean).join(" ");
    const sxVars = sx && typeof sx !== "string" ? sx == null ? void 0 : sx.vars : {};
    const varStyles = {};
    if (sxVars) {
      Object.entries(sxVars).forEach(([cssVariable, [value, isUnitLess]]) => {
        if (typeof value === "string" || isUnitLess) {
          varStyles[`--${cssVariable}`] = value;
        } else {
          varStyles[`--${cssVariable}`] = `${value}px`;
        }
      });
    }
    const styles = chunkQMF3JN35_js.__spreadValues(chunkQMF3JN35_js.__spreadValues({}, style), varStyles);
    return /* @__PURE__ */ jsxRuntime.jsx(Component, chunkQMF3JN35_js.__spreadValues({ ref, className: classes, style: styles }, other));
  }
);
process.env.NODE_ENV !== "production" ? Box.propTypes = {
  // ┌────────────────────────────── Warning ──────────────────────────────┐
  // │ These PropTypes are generated from the TypeScript type definitions. │
  // │    To update them, edit the d.ts file and run `pnpm proptypes`.     │
  // └─────────────────────────────────────────────────────────────────────┘
  /**
   * The component used for the root node.
   * Either a string to use a HTML element or a component.
   * Replacement for the emotion's `as` prop.
   */
  as: PropTypes__default.default.elementType,
  /**
   * The content of the component.
   */
  children: PropTypes__default.default.node,
  /**
   * The component used for the root node.
   * Either a string to use a HTML element or a component.
   */
  component: PropTypes__default.default.elementType,
  /**
   * The style extension prop that allows defining system overrides as well as additional CSS styles.
   */
  sx: PropTypes__default.default.oneOfType([PropTypes__default.default.func, PropTypes__default.default.object])
} : void 0;
var Box_default = Box;

module.exports = Box_default;
//# sourceMappingURL=Box.js.map

module.exports = exports.default;
//# sourceMappingURL=Box.js.map