import { a as Breakpoint } from './theme-aDBfke1X.mjs';
import { P as PolymorphicComponent } from './Box.d-KeTK9_Gy.mjs';
import 'react';
import 'csstype';
import '@mui/types';
import './sx.d-CCumutqY.mjs';

type ContainerBaseProps = {
  /**
   * If `true`, the left and right padding is removed.
   * @default false
   */
  disableGutters?: boolean;
  /**
   * Set the max-width to match the min-width of the current breakpoint.
   * This is useful if you'd prefer to design for a fixed set of sizes
   * instead of trying to accommodate a fully fluid viewport.
   * It's fluid by default.
   * @default false
   */
  fixed?: boolean;
  /**
   * Determine the max-width of the container.
   * The container width grows with the size of the screen.
   * Set to `false` to disable `maxWidth`.
   * @default 'lg'
   */
  maxWidth?: Breakpoint | false;
};

declare const Container: PolymorphicComponent<
  ContainerBaseProps & React.DetailsHTMLAttributes<HTMLDivElement>
>;

export { Container as default };
