import { a as Breakpoint } from './theme-aDBfke1X.mjs';
import { P as PolymorphicComponent } from './Box.d-KeTK9_Gy.mjs';
import 'react';
import 'csstype';
import '@mui/types';
import './sx.d-CCumutqY.mjs';

type HiddenUp = {
  [key in Breakpoint as `${key}Up`]?: boolean;
};
type HiddenDown = {
  [key in Breakpoint as `${key}Down`]?: boolean;
};

interface HiddenBaseProps extends HiddenUp, HiddenDown {
  className?: string;
  only?: Breakpoint | Breakpoint[];
}

declare const Hidden: PolymorphicComponent<
  HiddenBaseProps & React.DetailsHTMLAttributes<HTMLDivElement>
>;

export { Hidden as default };
