import { a as Breakpoint } from './theme-aDBfke1X.js';
import { P as PolymorphicComponent } from './Box.d-Bf-NOUoN.js';
import 'react';
import 'csstype';
import '@mui/types';
import './sx.d-Cr4VrsXR.js';

type HiddenUp = {
  [key in Breakpoint as `${key}Up`]?: boolean;
};
type HiddenDown = {
  [key in Breakpoint as `${key}Down`]?: boolean;
};

interface HiddenBaseProps extends HiddenUp, HiddenDown {
  className?: string;
  only?: Breakpoint | Breakpoint[];
}

declare const Hidden: PolymorphicComponent<
  HiddenBaseProps & React.DetailsHTMLAttributes<HTMLDivElement>
>;

export = Hidden;
