import * as CSS from 'csstype';
import { a as Breakpoint } from './theme-aDBfke1X.mjs';
import { P as PolymorphicComponent } from './Box.d-KeTK9_Gy.mjs';
import 'react';
import '@mui/types';
import './sx.d-CCumutqY.mjs';

type CssProperty<T> = T | Array<T> | Partial<Record<Breakpoint, T>>;

type StackBaseProps = {
  spacing?: CssProperty<number | string>;
  direction?: CssProperty<CSS.StandardLonghandProperties['flexDirection']>;
  divider?: React.ReactNode;
  className?: string;
};

declare const Stack: PolymorphicComponent<
  StackBaseProps & React.DetailsHTMLAttributes<HTMLDivElement>
>;

export { Stack as default };
