import { Expression } from '@babel/types';
import { CallParam, TemplateParam, Params, TailProcessorParams, ValueCache } from '@wyw-in-js/processor-utils';
import { CSSInterpolation } from '@emotion/serialize';
import { B as BaseProcessor } from './base-processor-FyHksda3.js';
import '@wyw-in-js/shared';

type Primitive = string | number | boolean | null | undefined;
type TemplateCallback = (params: Record<string, unknown> | undefined) => string | number;
declare class GlobalCssProcessor extends BaseProcessor {
    callParam: CallParam | TemplateParam;
    constructor(params: Params, ...args: TailProcessorParams);
    build(values: ValueCache): void;
    private handleTemplate;
    generateArtifacts(styleObjOrTaggged: CSSInterpolation | string[], ...args: Primitive[]): void;
    private handleCall;
    doEvaltimeReplacement(): void;
    doRuntimeReplacement(): void;
    get asSelector(): string;
    get value(): Expression;
}

export { GlobalCssProcessor, type Primitive, type TemplateCallback };
