'use strict';

require('./chunk-QMF3JN35.js');
var helperPluginUtils = require('@babel/helper-plugin-utils');

/**
  * @pigment-css/react v0.0.30
  *
  * @license MIT
  * This source code is licensed under the MIT license found in the
  * LICENSE file in the root directory of this source tree.
  */
 
var removePropTypesPlugin = helperPluginUtils.declare((api) => {
  api.assertVersion(7);
  return {
    name: "@pigmentcss/wyw-remove-prop-types-plugin",
    visitor: {
      AssignmentExpression(path) {
        const left = path.get("left");
        if (!left.isMemberExpression()) {
          return;
        }
        const property = left.get("property");
        const isPropTypes = property.isIdentifier({ name: "propTypes" });
        const isMuiName = property.isIdentifier({ name: "muiName" });
        if (!isPropTypes && !isMuiName) {
          return;
        }
        const parentExpression = path.findParent((p) => p.isExpressionStatement());
        if (parentExpression) {
          parentExpression.remove();
        }
      }
    }
  };
});

exports.removePropTypesPlugin = removePropTypesPlugin;
//# sourceMappingURL=remove-prop-types-plugin.js.map
//# sourceMappingURL=remove-prop-types-plugin.js.map